28 октября 2006 г.

init.d или autorun по-debian'овски.

Начнем с того, что у нас появилась какая-то служба, которую необходимо заставить включаться вместе с операционкой и работать в фоне. Назовем ее InetAccess. И пусть путь к ней будет выглядеть как /usr/bin/inetaccess
Теперь нам нужно заставить ее работать. При чем запускаться не самой по себе в виде команды, а скажем, с параметрами a, b, c и d, то есть команда должна выглядеть так:

$ inetaccess a b c d

Делается это все весьма просто, вопреки мнимой сложности. Итак, идем в каталог /etc/init.d

$ cd /etc/init.d

там находится файл-пример скрипта "автозагрузки", называется он skeleton. Создаем из него наш скрипт автозапуска (назовем его соответствующим образом - inetaccess). И начинаем его беспощадно править.

/etc/init.d# cp skeleton inetaccess
/etc/init.d# chmod 755 inetaccess
/etc/init.d# nano inetaccess

Итак, мы смотрим содержимое нашего скрипта. Команда chmod необходима, так как для файла-примера skeleton не выставлены права на исполнение. Вернемся к нашим баранам. Вот так выглядит тело файла skeleton (и тело текущего состояния файла inetaccess):
#! /bin/sh
### BEGIN INIT INFO
# Provides: skeleton
# Required-Start: $local_fs $remote_fs
# Required-Stop: $local_fs $remote_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Example initscript
# Description: This file should be used to construct scripts to be
# placed in /etc/init.d.
### END INIT INFO

# Author: Foo Bar
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/usr/sbin:/usr/bin:/sbin:/bin
DESC="Description of the service"
NAME=daemonexecutablename
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="--options args"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null || return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- $DAEMON_ARGS || return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
return 0
}

case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
exit 3
;;
esac

:
Строки:
[ -x "$DAEMON" ] || exit 0
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
[ -f /etc/default/rcS ] && . /etc/default/rcS
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null || return 1
|| return 2
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
[ "$?" = 2 ] && return 2
rm -f $PIDFILE
return "$RETVAL"
do_reload() {
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
return 0
}
Сразу комментируем. Они нам просто не нужны.
Теперь займемся правкой нужных строк. Для упрощения нам предлагают использовать набор переменных. С них и начнем.

DESC="Description of the service" - описание службы. Как хотите, так ее и обзовите. Назовем ее "InetAccess"

NAME=daemonexecutablename - запускаемая команда. Вспоминаем, что у нас она выглядит inetaccess.

DAEMON=/usr/sbin/$NAME - меняем адрес на нужный. Переменная NAME уже задана. Ее и оставляем. Адрес нашей программы /usr/bin/$NAME

DAEMON_ARGS="--options args" - здесь надо ввести аргументы запуска. У нас они не носят характер опций, то есть вместо "--options args" вводим "a b c d".

Готово? Теперь находим строки:
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- $DAEMON_ARGS \
Меняем на:
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --background -- $DAEMON_ARGS > /dev/null \
Готово? Теперь сохраняем, выходим (для nano: Ctrl+O, Enter, Ctrl+X) и проверяем, справились ли мы. Для этого на месте производим следующую манипуляцию:

$ ./inetaccess start

Если все в порядке, вы увидите сообщение о запуске команды. Если что-то не так, вы увидите сообщение об ошибке. Итак, скрипт готов. Теперь надо заставить его запускаться при каждом включении компьютера. Для этого выполняем следующую команду:

/etc/init.d# update-rc.d defaults 99

Если после выполнения вы увидите сообщение о том, что файлы были успешно созданы в таких-то каталогах, можете быть довольны собой и перезагружать систему проверки ради. Если все прошло удачно, то после перезагрузки служба окажется запущенной.

3 комментария:

serhiy cherevko комментирует...

Круто. Недавно была такая проблема. Не помню точно что я хотел занести в inet.d, но там были инструкции для Red Hat. В последнем заместь /etc/init.d стоит /etc/rc.d/init.d (вроде так). Было сказано, что просто копируете файл в эту папку и все. По анологии проделал с Kubuntu. Не получилось. Не знаю почему. Быстро сдался. Ленивый стал. Все что надо вроде поставил, на том что не сильно надо, быстро сдаюсь

Анонимный комментирует...

Реально, хорошо описал всё. Искал не долго, но когда нарвался на эту статью, закончил поиски. Буду так и делать.

vak комментирует...

еще бы где-нибудь найти как писать эти самые службы, чтобы они дружили с start-stop-daemon -- вообще было бы супер. а то я свой баш скриптик никак не подружу с start-stop-daemon.

Отправить комментарий